%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name SDL
%global mingw_build_win32 1
%global mingw_build_win64 1

Name:           mingw-SDL
Version:        1.2.13
Release:        11%{?dist}
Summary:        MinGW Windows port of SDL cross-platform multimedia library

License:        LGPLv2+
Group:          Development/Libraries
URL:            http://www.libsdl.org/
Source0:        http://www.libsdl.org/release/SDL-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

# Patches from native version.
Patch0:         SDL-1.2.10-byteorder.patch
Patch17:        SDL-1.2.13-libdir.patch
Patch21:        SDL-1.2.12-multilib.patch
Patch23:        SDL-1.2.11-dynamic-esd.patch
Patch24:        SDL-1.2.12-x11dyn64.patch
Patch25:        SDL-1.2.12-disable_yasm.patch
Patch26:        SDL-1.2.13-dynamic-pulse.patch
Patch27:        SDL-1.2.13-pulse-rework.patch
Patch28:        SDL-1.2.13-audiodriver.patch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw64-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw64-binutils
BuildRequires:  mingw32-iconv
BuildRequires:  mingw64-iconv

Requires:       pkgconfig

# Not required at the moment, but SDL does contain plenty of C++ code,
# I just haven't worked out how to enable it.
#BuildRequires:  mingw32-gcc-c++

# If we have nasm in the future, then this would enable future
# optimizations on x86-based architectures.
#%ifarch %{ix86}
#BuildRequires: nasm
#%endif

%{?mingw_default_requires}
%{?mingw_debug_package}
 
%description -n mingw-%{mingw_pkg_name}
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.


# Mingw32
%package -n mingw32-%{mingw_pkg_name}
Summary:        %{summary}
# kraxel pointed out that the headers need <iconv.h>, hence:
Requires:       mingw32-iconv

%description -n mingw32-%{mingw_pkg_name}
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.

# Mingw64
%package -n mingw64-%{mingw_pkg_name}
Summary:        %{summary}
# kraxel pointed out that the headers need <iconv.h>, hence:
Requires:       mingw64-iconv

%description -n mingw64-%{mingw_pkg_name}
Simple DirectMedia Layer (SDL) is a cross-platform multimedia library
designed to provide fast access to the graphics frame buffer and audio
device.


%prep
%setup -q -n SDL-%{version}
%patch0 -p1 -b .byteorder
%patch17 -p1 -b .libdir
%patch21 -p1 -b .multilib
%patch23 -p1 -b .dynamic-esd
%patch24 -p1 -b .x11dyn64
%patch25 -p1 -b .disable_yasm
%patch26 -p1 -b .dynamic-pulse
%patch27 -p1 -b .pulse-rework
%patch28 -p1 -b .audiodriver

%build
%mingw_configure "--disable-video-svga" "--disable-video-ggi" "--disable-video-aalib" "--disable-debug" "--enable-sdl-dlopen" "--enable-dlopen" "--disable-arts-shared" "--disable-esd-shared" "--enable-pulseaudio-shared" "--disable-alsa" "--disable-rpath" "--disable-directx"

%mingw_make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
%mingw_make_install DESTDIR=$RPM_BUILD_ROOT

# Remove static libraries but DON'T remove *.dll.a files.
rm $RPM_BUILD_ROOT%{mingw32_libdir}/libSDL.a
rm $RPM_BUILD_ROOT%{mingw64_libdir}/libSDL.a

# Actually libSDLmain.a seems to be required.  It just contains
# a single object file called SDL_win32_main.o.
#rm $RPM_BUILD_ROOT%{mingw32_libdir}/libSDLmain.a
#rm $RPM_BUILD_ROOT%{mingw64_libdir}/libSDLmain.a

# Delete man pages since they duplicate what is already available
# in base Fedora package.
rm $RPM_BUILD_ROOT%{mingw32_mandir}/man3/*.3*
rm $RPM_BUILD_ROOT%{mingw64_mandir}/man3/*.3*

%clean
rm -rf $RPM_BUILD_ROOT


# Mingw32
%files -n mingw32-%{mingw_pkg_name}
%defattr(-,root,root)
%doc COPYING
%{mingw32_bindir}/SDL.dll
%{mingw32_bindir}/sdl-config
%{mingw32_libdir}/libSDL.dll.a
%{mingw32_libdir}/libSDL.la
%{mingw32_libdir}/libSDLmain.a
%{mingw32_libdir}/pkgconfig/sdl.pc
%{mingw32_datadir}/aclocal/sdl.m4
%{mingw32_includedir}/SDL

# Mingw64
%files -n mingw64-%{mingw_pkg_name}
%defattr(-,root,root)
%doc COPYING
%{mingw64_bindir}/SDL.dll
%{mingw64_bindir}/sdl-config
%{mingw64_libdir}/libSDL.dll.a
%{mingw64_libdir}/libSDL.la
%{mingw64_libdir}/libSDLmain.a
%{mingw64_libdir}/pkgconfig/sdl.pc
%{mingw64_datadir}/aclocal/sdl.m4
%{mingw64_includedir}/SDL


%changelog
* Sat May 14 2011 Marc-André Lureau <marcandre.lureau@redhat.com> - 1.2.13-11
- Updated to newer mingw instructions (with mingw64 support)
- Disable alsa, arts, esd, as it's not useful on Windows

* Sun Feb 13 2011 Erik van Pienbroek <epienbro@fedoraproject.org> - 1.2.13-10
- Build without directx support as it isn't ready yet for the mingw-w64 toolchain

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.13-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.13-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Apr 29 2009 Richard W.M. Jones <rjones@redhat.com> - 1.2.13-7
- Add runtime Requires mingw32-iconv (kraxel).

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.13-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Fri Feb 20 2009 Richard W.M. Jones <rjones@redhat.com> - 1.2.13-5
- Rebuild for mingw32-gcc 4.4

* Tue Jan 13 2009 Richard W.M. Jones <rjones@redhat.com> - 1.2.13-4
- Verify we are still up to date with Fedora release.
- Include COPYING in documentation.
- Build with dlfcn.
- List all BRs.
- No need to package the man pages, don't duplicate what's in the
  base Fedora package already.
- Requires pkgconfig.

* Fri Oct 24 2008 Richard W.M. Jones <rjones@redhat.com> - 1.2.13-2
- Initial RPM release.
